﻿Type=Activity
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
	#Extends: android.support.v7.app.AppCompatActivity
#End Region

Sub Process_Globals
	Dim ref As DatabaseReference
	Dim tempuserref As DatabaseReference 
End Sub

Sub Globals
	Dim mapParGlob As Map
	Dim xml As XmlLayoutBuilder
	Private CustomListView1 As CustomListView
	
	Private Content As Panel
	Private panPost As Panel
	Private Toolbar As ACToolBarLight

	Private imgStar As ImageView
	Private imgUserPic As ImageView
	Private imgUserPic2 As ImageView
	Private lblComment As Label
	Private lblCommentor As Label
	Private lblHiddenId As Label
	Private lblPostText As Label
	Private lblPostTitle As Label
	Private lblStarCount As Label
	Private lblUsername As Label
	Private MaskedEditText2 As MaskedEditText
	Private panCustListCell As Panel
	Private panCustListCell2 As Panel
	Private panCustLV As Panel	

End Sub

Sub Activity_Create(FirstTime As Boolean)
	' ─────────────────
	' Load basic layout 
	' ─────────────────
	Activity.LoadLayout("postdetail")
	Toolbar.Color = 0xFF039BE5
	Toolbar.TitleTextColor = Colors.White
	Toolbar.Title = Starter.mapCurrentUser.get("DisplayName")
	Toolbar.InitMenuListener

	panPost.LoadLayout("cellitem")

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

#If Java
public boolean _onCreateOptionsMenu(android.view.Menu menu) {
	if (processBA.subExists("activity_createmenu")) {
		processBA.raiseEvent2(null, true, "activity_createmenu", false, new de.amberhome.objects.appcompat.ACMenuWrapper(menu));
		return true;
	}
	else
		return false;
}
#End If
Sub Activity_CreateMenu(Menu As ACMenu)
	Menu.Clear
	Menu.Add(1, 3, "leave", Null)
End Sub
Sub Toolbar_MenuItemClick (Item As ACMenuItem)
	Log($"#-PostDetails.Toolbar_MenuItemClick──┐   Item.Id=${Item.Id}, Starter.bolIsAuthEx=${Starter.bolIsAuthEx}"$)
	Select Case Item.Id
	Case 1
		Activity.Finish
	End Select
End Sub

Sub Initialize(mapPar As Map)
	Log("#-PostDetails.Initialize")
	Log("#-  mapPar=" & mapPar)
	mapParGlob = mapPar
	
	' ─────────────────────
	' Fill Details for Post
	' ─────────────────────
	lblPostText.Text  = mapParGlob.Get("lblPostText.Text")
	lblPostTitle.Text = mapParGlob.Get("lblPostTitle.Text")
	lblUsername.Text  = mapParGlob.Get("lblUsername.Text")
	lblStarCount.Text = ""
	imgStar.Visible = False

	Dim bd As BitmapDrawable = xml.GetDrawable("ic_action_account_circle_40")	' Default user picture
	imgUserPic.Background = bd
	
	panCustLV.LoadLayout("custlv")

	PrepRefOnTopnode("")




	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	'#### Only local TESTDATA to verify the function of the CustomListView ####	
	For i= 1 To 6
		CustomListView1.Add(CreateListItem("Testcommentor xyz" & ((i+18)*42), "Test comment No. " & i, CustomListView1.AsView.Width, 120dip ), 120dip, i)
	Next
	'#### Only local TESTDATA to verify the function of the CustomListView ####	




	' x281
	'
	' ...unfinished: Here should be a Query of "post-comments" to get the snapshot-data to fill the CustomListView1 with the content of the childnodes
	'
	'refRecent.Initialize("refRecent" , ref.Child("post-comments\" & strCommentId) ) 
	'refRecent.LimitToFirst(3) 
	' ..query...
	' ...

	
End Sub

Sub CreateListItem(strUsername As String, strComment As String, Width As Int, Height As Int) As Panel
	' https://www.b4x.com/android/forum/threads/class-customlistview-a-flexible-list-based-on-scrollview.19567/
	Dim p As Panel
	p.Initialize("")
	Activity.AddView(p, 0, 0, Width, Height)
	p.LoadLayout("CellItem2")
	p.RemoveView
	
	lblCommentor.Text = strUsername 
	lblComment.Text = strComment

	Dim bd As BitmapDrawable = xml.GetDrawable("ic_action_account_circle_40")	' Default user picture
	imgUserPic.Background = bd
	
	Return p
End Sub

Sub lblPostText_Click
	Msgbox(lblPostText.Text, lblPostTitle.Text)
End Sub

Sub panCustListCell_Click
	Log("#-panCustListCell_Click")
	Try
		Dim index As Int = CustomListView1.GetItemFromView(Sender)
	Catch
		Log("PD-142")
		Return
	End Try
	
	' Find needed views via tag	
	Dim pnl As Panel = CustomListView1.GetPanel(index)
	For Each v As View In pnl.GetAllViewsRecursive
		Dim vX As View = v
		If vX Is Label Then 
			Select Case True
			Case vX.Tag = "lblComment"
				Dim lblComment As Label = vX
			Case vX.Tag = "lblCommentor"
				Dim lblCommentor As Label = vX
			End Select
		End If
	Next
	Msgbox(lblComment.Text, lblCommentor.Text)
End Sub

Sub MaskedEditText2_EnterPressed
	lblPost_Click	
End Sub

Sub lblPost_Click
	Log("#-lblPost_Click")
	Log("#-  MaskedEditText2.Text=" & MaskedEditText2.Text)
	If validateForm Then 
		' Create post and close activity
		Dim bolWpOk As Boolean = postComment(Starter.mapCurrentUser.GetDefault("Uid", ""), Starter.mapCurrentUser.GetDefault("DisplayName", ""), mapParGlob.Get("lblHiddenId.Text"), MaskedEditText2.Text)
		
		
		' Refresh list of comments
		' ...
		
	End If
	MaskedEditText2.Text = ""
End Sub

Sub validateForm As Boolean 
	If MaskedEditText2.Text.Length = 0 Then
		MaskedEditText2.ShowError("Required")
		Return False
	End If
 
 	Return True
End Sub

Sub PrepRefOnTopnode(strNewTopNode As String)
	Log("#-PrepRefOnTopnode, strNewTopNode=" & strNewTopNode)
	
	' First make us a reference to the TopLevelNode
    ref.Initialize("Reference", Starter.realtime.getReferencefromUrl($"https://${Starter.strFirebaseProjectId}.firebaseio.com/${strNewTopNode}"$) )
    ref.addChildEventListener
    ref.addListenerForSingleValueEvent
    ref.addValueEventListener	
 
	'  Make sure the UserId is in the "users" list
	Dim strUidPath As String = "users/" & Starter.mapCurrentUser.GetDefault("Uid", "-1")  ' <--Point A
	Log("#-  strUidPath=" & strUidPath)
	tempuserref.Initialize("tempuserref" , ref.Child(strUidPath) ) ' e.g. <-- https://yyymyprojectid123.firebaseio.com/testnode1/users/-KTclQUDpdelku0RSZ5fq
	tempuserref.Value = Starter.mapCurrentUser ' <-- We just set the map with the userinfo as "the value" and it will be added or updated to the path above (Point A) automatically by Firebase
	Log("#-  tempuserref.Key=" & tempuserref.Key)
	
End Sub

Sub postComment(strUid As String, strUNam As String, strPostId As String, strText As String) As Boolean 
	Log("#-postComment, strUid=" & strUid & ", strUNam=" & strUNam & ", strText=" & strText)	
	'  
   	Dim tempref As DatabaseReference = ref.Child("post-comments") ' <-- One node we want to write the data to
    Dim posts As DatabaseReference = tempref.push ' <-- We just needed this reference to get the autogenerated KEY
    Dim key As String = posts.Key 
    Log("#-  key=" & key) 

    Dim mapPostValues As Map
    mapPostValues.Initialize
    mapPostValues.Put("uid", strUid)
    mapPostValues.Put("author", strUNam)
    mapPostValues.Put("text", strText)

    Dim strUk1 As String = "/post-comments/" & strPostId & "/" & key
    Log("#-  strUk1=" & strUk1) 
 
    Dim childUpdates As Map
    childUpdates.Initialize
    childUpdates.Put(strUk1, mapPostValues)
    ref.updateChildren(childUpdates)      ' <-- This is the "atomic" update. ONE start of transaction no matter how many elements the map has
    'Log("#-  childUpdates=" & childUpdates)	
	
	Return True
	
End Sub

Sub Reference_onCancelled(errnum As Int,error As String)
	Log(" ")
    Log($"#- ═── Reference_onCancelled(${errnum},${error})"$)
End Sub
Sub Reference_onChildAdded(snapshot As Object, child As String)
	Log(" ")
	Log($"#- ═── Reference_onChildAdded(${child})"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildChanged(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── Reference_onChildChanged(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildMoved(snapshot As Object, child As String)
	Log(" ")
    Log($"#- ═── Reference_onChildMoved(${child})"$) 
	showSnapshot(snapshot)
End Sub
Sub Reference_onChildRemoved(snapshot As Object)
	Log(" ")
    Log($"#- ═── Reference_onChildRemoved()"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onDataChange(snapshot As Object)
	Log(" ")
    Log($"#- ═── Reference_onDataChange()"$)
	showSnapshot(snapshot)
End Sub
Sub Reference_onComplete(errorCode As Int, errorMessage As String, errObj As Object, dbref As Object)
    Log($"#-Reference_onComplete(${errorCode},${errorMessage})"$)
    If errObj <> Null Then
        Dim err As DatabaseError = errObj
        Log($"#-  err.Code   =${err.Code}"$)
        Log($"#-  err.Details=${err.Details}"$)
        Log($"#-  err.Message=${err.Message}"$)
    End If
    If dbref <> Null Then
        Dim ref As DatabaseReference = dbref
        Log($"  ref.Key=${ref.Key}"$)
    End If
End Sub

Sub tempuserref_oncomplete(errorCode As Int, errorMessage As String, errObj As Object) ', dbRef As Object)
	Log(" ")
    Log($"#- ═── tempuserref_onComplete(${errorCode}, '${errorMessage}')"$)
    If errObj <> Null Then
        Dim err As DatabaseError = errObj
        Log($"#-  err.Code   =${err.Code}"$)
        Log($"#-  err.Details=${err.Details}"$)
        Log($"#-  err.Message=${err.Message}"$)
    End If
End Sub

Sub showSnapshot(snapX As DataSnapshot)
	Dim snap As DataSnapshot = snapX
	Log("#-Snapshot:" & CRLF & snap.Value & CRLF )
End Sub